import {
  MyBetaModalFormProps,
  MyButtons,
  MyFormItems,
  MyModalFormProps,
  rulesHelper,
} from '@/common';
import { Apis } from '@/gen/Apis';
import { BetaSchemaForm } from '@ant-design/pro-components';
import { Form, message } from 'antd';

export default function Create(props: MyBetaModalFormProps) {
  const [form] = Form.useForm();

  return (
    <BetaSchemaForm<ApiTypes.Meter.HouseMeters.Store>
      {...MyModalFormProps.props}
      title={`添加仪表`}
      // wrapperCol={{ span: 24 }}
      layout="horizontal"
      labelCol={{ span: 6 }}
      wrapperCol={{ span: 18 }}
      labelAlign="left"
      width="600px"
      key={new Date().getTime()}
      trigger={<MyButtons.Create title={`添加仪表`} />}
      form={form}
      onOpenChange={(open: any) => {
        if (open) {
          form.resetFields(); // 清空表单数据
        }
      }}
      onFinish={async (values) =>
        Apis.Meter.HouseMeters.Store({
          ...values,
          latest_value: values.initial_value,
          latest_time: values.initial_time,
          asset_projects_id: props?.item?.asset_projects_id,
          meter_type: props?.item?.meter_type,
          usage_type: props?.item?.usage_type,
        })
          .then(() => {
            props.reload?.();
            message.success(props.title + '成功');
            return true;
          })
          .catch(() => false)
      }
      columns={[
        {
          key: 'name',
          title: '仪表编号',
          colProps: { span: 24 },
          formItemProps: { ...rulesHelper.text },
        },
        {
          key: 'multiple',
          title: '倍率',
          colProps: { span: 24 },
          formItemProps: { ...rulesHelper.text },
        },
        {
          key: 'initial_value',
          title: '初始抄表读数',
          valueType: 'number',
          colProps: { span: 24 },
          formItemProps: { ...rulesHelper.number },
        },
        {
          key: 'initial_time',
          title: '初始抄表时间',
          valueType: 'dateTime',
          colProps: { span: 24 },
          formItemProps: { ...rulesHelper.text },
          fieldProps: {
            disabledDate: (current: any) => {
              // 禁用未来的日期
              return current && current > new Date();
            },
            disabledTime: (current: any) => {
              // 如果是今天，禁用未来的时间
              if (
                current &&
                current.format('YYYY-MM-DD') ===
                  new Date().toISOString().split('T')[0]
              ) {
                const now = new Date();
                return {
                  disabledHours: () => {
                    const hours = [];
                    for (let i = now.getHours() + 1; i < 24; i++) {
                      hours.push(i);
                    }
                    return hours;
                  },
                  disabledMinutes: (selectedHour: number) => {
                    if (selectedHour === now.getHours()) {
                      const minutes = [];
                      for (let i = now.getMinutes() + 1; i < 60; i++) {
                        minutes.push(i);
                      }
                      return minutes;
                    }
                    return [];
                  },
                  disabledSeconds: (
                    selectedHour: number,
                    selectedMinute: number,
                  ) => {
                    if (
                      selectedHour === now.getHours() &&
                      selectedMinute === now.getMinutes()
                    ) {
                      const seconds = [];
                      for (let i = now.getSeconds() + 1; i < 60; i++) {
                        seconds.push(i);
                      }
                      return seconds;
                    }
                    return [];
                  },
                };
              }
              return {};
            },
          },
        },
        MyFormItems.UploadImages({
          key: 'images',
          title: '仪表图片',
          tooltip: '只能上传1张图片',
          max: 1,
          colProps: { span: 24 },
          formItemProps: { required: true },
        }),
        {
          key: 'remark',
          title: '备注',
          valueType: 'textarea',
          colProps: { span: 24 },
        },
      ]}
    />
  );
}
